### 实验十一 温湿度传感器

#### 温湿度传感器原理

这里我们以DHT11为例使用，DHT11温湿度传感器工作原理是把空气中的温湿度通过一定检测装置，测量到温湿度后，按照一定的规律变换成电信号或其它所需的信息输出。

DHT11 与单片机之间能采用简单的单总线进行通信，仅仅需要一个 I/O口。传感器内部湿度和温度数据40Bit的数据一次性传给单片机，数据采用 校验和方式进行校验，有效的保证数据传输的准确性。DHT11 功耗很低，5V 电 源电压下，工作平均最大电流 0.5mA。

 DHT11数字湿温度传感器采用单总线数据格式，即单个数据引脚端口完成输入输出双向传输。

 其数据包由5Byte（40Bit）组成。数据分小数部分和整数部分,具 体格式在下面说明。 一次完整的数据传输为40bit，高位先出。

**数据格式：8bit湿度整数数据+8bit湿度小数数据 +8bit温度整数数据+8bit温度小数数据 +8bit校验和**

#### 代码讲解

DHT11所传输的数据是一个40Bit的数据，但是Arduino有对应的库方便我们使用，同理其它大部分传感器也有相对于的库来使用。

下载好DHT11的库后，烧录以下代码，连接好对应的引脚即可在采集并在串口打印对应的温湿度数据。

![image-20221206105848320](E:\派哟项目\Hexbot项目\HEXBot_使用手册\ESP32使用手册\实验十一 温湿度传感器\DHT11.png)

这里涉及一些函数如下

**dht.begin();**

DHT系列传感器的初始化函数

**dht.readHumidity();**

读取湿度数据

**dht.readTemperature();** 

读取温度数据

#### 程序源码

```
#include <DHT.h>

#include <DHT_U.h>

#define DHTPIN 16  

#define DHTTYPE DHT11  

DHT dht(DHTPIN, DHTTYPE);  

void setup() {

 Serial.begin(115200);

 dht.begin(); 

}



void loop()

{ 

 float h = dht.readHumidity();  

 float t = dht.readTemperature(); 

 Serial.print("相对湿度: ");  

 Serial.print(h);

 Serial.println(" %RH");

 Serial.print("温度: ");

 Serial.print(t);

 Serial.println(" °C");

 delay(1000);

}
```

